----------------------------------------------------------------------------------
-- Company:
-- Engineer: IGNACIO SERNA ESCOBEDO & SANTIAGO VIVES MERINO
-- 
-- Create Date: 10.01.2020
-- Design Name:
-- Module Name: CHRONO_COUNTER - STRUCTURAL
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision: 16.01.2020
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity CHRONO_COUNTER is
	generic(
		CHRONO_COUNTER_N		: positive := 4;
		CHRONO_COUNTER_LIMIT_0	: positive := 9;
		CHRONO_COUNTER_LIMIT_1	: positive := 9;
		CHRONO_COUNTER_LIMIT_2	: positive := 9;
		CHRONO_COUNTER_LIMIT_3	: positive := 9;
		CHRONO_COUNTER_LIMIT_4	: positive := 9;
		CHRONO_COUNTER_LIMIT_5	: positive := 5;
		CHRONO_COUNTER_LIMIT_6	: positive := 9;
		CHRONO_COUNTER_LIMIT_7	: positive := 5
	);
	port(
		CHRONO_COUNTER_MODE : in std_logic;
		CHRONO_COUNTER_CLOCK : in std_logic;
		CHRONO_COUNTER_RESET : in std_logic;
		CHRONO_COUNTER_ENABLE : in std_logic;
		CHRONO_COUNTER_LOAD_0 : in std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_LOAD_1 : in std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_LOAD_2 : in std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_LOAD_3 : in std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_LOAD_4 : in std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_LOAD_5 : in std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_LOAD_6 : in std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_LOAD_7 : in std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_OUTPUT_0 : out std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_OUTPUT_1 : out std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_OUTPUT_2 : out std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_OUTPUT_3 : out std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_OUTPUT_4 : out std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_OUTPUT_5 : out std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_OUTPUT_6 : out std_logic_vector(CHRONO_COUNTER_N-1 downto 0);
		CHRONO_COUNTER_OUTPUT_7 : out std_logic_vector(CHRONO_COUNTER_N-1 downto 0)
	);
end entity CHRONO_COUNTER;

architecture STRUCTURAL of CHRONO_COUNTER is
	component  COUNTER
		generic(
			COUNTER_N : positive := 4;
			COUNTER_LIMIT : positive := 9
		);
		port(
			COUNTER_CLOCK : in std_logic;
			COUNTER_RESET : in std_logic;
			COUNTER_ENABLE : in std_logic;
			COUNTER_MODE : in std_logic;
			COUNTER_LOAD : in std_logic_vector(COUNTER_N-1 downto 0);
			COUNTER_OUTPUT : out std_logic_vector(COUNTER_N-1 downto 0);
			COUNTER_CARRIER : out std_logic
		);
	end component;
	signal GLOBAL_RESET : std_logic;
	signal COUNTER_CARRIER_0 : std_logic;
	signal COUNTER_CARRIER_1 : std_logic;
	signal COUNTER_CARRIER_2 : std_logic;
	signal COUNTER_CARRIER_3 : std_logic;
	signal COUNTER_CARRIER_4 : std_logic;
	signal COUNTER_CARRIER_5 : std_logic;
	signal COUNTER_CARRIER_6 : std_logic;
	signal COUNTER_CARRIER_7 : std_logic;
begin
	COUNTER_0 : COUNTER
		generic map(
			COUNTER_N		=> CHRONO_COUNTER_N,
			COUNTER_LIMIT	=> CHRONO_COUNTER_LIMIT_0
		)
		port map(
			COUNTER_CLOCK	=> CHRONO_COUNTER_CLOCK,
			COUNTER_RESET	=> GLOBAL_RESET,
			COUNTER_ENABLE	=> CHRONO_COUNTER_ENABLE,
			COUNTER_MODE	=> CHRONO_COUNTER_MODE,
			COUNTER_LOAD	=> CHRONO_COUNTER_LOAD_0,
			COUNTER_OUTPUT	=> CHRONO_COUNTER_OUTPUT_0,
			COUNTER_CARRIER	=> COUNTER_CARRIER_0
		);
	COUNTER_1 : COUNTER
		generic map(
			COUNTER_N		=> CHRONO_COUNTER_N,
			COUNTER_LIMIT	=> CHRONO_COUNTER_LIMIT_1
		)
		port map(
			COUNTER_CLOCK	=> CHRONO_COUNTER_CLOCK,
			COUNTER_RESET	=> GLOBAL_RESET,
			COUNTER_ENABLE	=> COUNTER_CARRIER_0,
			COUNTER_MODE	=> CHRONO_COUNTER_MODE,
			COUNTER_LOAD	=> CHRONO_COUNTER_LOAD_1,
			COUNTER_OUTPUT	=> CHRONO_COUNTER_OUTPUT_1,
			COUNTER_CARRIER	=> COUNTER_CARRIER_1
		);
	COUNTER_2 : COUNTER
		generic map(
			COUNTER_N		=> CHRONO_COUNTER_N,
			COUNTER_LIMIT	=> CHRONO_COUNTER_LIMIT_2
		)
		port map(
			COUNTER_CLOCK	=> CHRONO_COUNTER_CLOCK,
			COUNTER_RESET	=> GLOBAL_RESET,
			COUNTER_ENABLE	=> COUNTER_CARRIER_1,
			COUNTER_MODE	=> CHRONO_COUNTER_MODE,
			COUNTER_LOAD	=> CHRONO_COUNTER_LOAD_2,
			COUNTER_OUTPUT	=> CHRONO_COUNTER_OUTPUT_2,
			COUNTER_CARRIER	=> COUNTER_CARRIER_2
		);
	COUNTER_3 : COUNTER
		generic map(
			COUNTER_N		=> CHRONO_COUNTER_N,
			COUNTER_LIMIT	=> CHRONO_COUNTER_LIMIT_3
		)
		port map(
			COUNTER_CLOCK	=> CHRONO_COUNTER_CLOCK,
			COUNTER_RESET	=> GLOBAL_RESET,
			COUNTER_ENABLE	=> COUNTER_CARRIER_2,
			COUNTER_MODE	=> CHRONO_COUNTER_MODE,
			COUNTER_LOAD	=> CHRONO_COUNTER_LOAD_3,
			COUNTER_OUTPUT	=> CHRONO_COUNTER_OUTPUT_3,
			COUNTER_CARRIER	=> COUNTER_CARRIER_3
		);
	COUNTER_4 : COUNTER
		generic map(
			COUNTER_N		=> CHRONO_COUNTER_N,
			COUNTER_LIMIT	=> CHRONO_COUNTER_LIMIT_4
		)
		port map(
			COUNTER_CLOCK	=> CHRONO_COUNTER_CLOCK,
			COUNTER_RESET	=> GLOBAL_RESET,
			COUNTER_ENABLE	=> COUNTER_CARRIER_3,
			COUNTER_MODE	=> CHRONO_COUNTER_MODE,
			COUNTER_LOAD	=> CHRONO_COUNTER_LOAD_4,
			COUNTER_OUTPUT	=> CHRONO_COUNTER_OUTPUT_4,
			COUNTER_CARRIER	=> COUNTER_CARRIER_4
		);
	COUNTER_5 : COUNTER
		generic map(
			COUNTER_N		=> CHRONO_COUNTER_N,
			COUNTER_LIMIT	=> CHRONO_COUNTER_LIMIT_5
		)
		port map(
			COUNTER_CLOCK	=> CHRONO_COUNTER_CLOCK,
			COUNTER_RESET	=> GLOBAL_RESET,
			COUNTER_ENABLE	=> COUNTER_CARRIER_4,
			COUNTER_MODE	=> CHRONO_COUNTER_MODE,
			COUNTER_LOAD	=> CHRONO_COUNTER_LOAD_5,
			COUNTER_OUTPUT	=> CHRONO_COUNTER_OUTPUT_5,
			COUNTER_CARRIER	=> COUNTER_CARRIER_5
		);
	COUNTER_6 : COUNTER
		generic map(
			COUNTER_N		=> CHRONO_COUNTER_N,
			COUNTER_LIMIT	=> CHRONO_COUNTER_LIMIT_6
		)
		port map(
			COUNTER_CLOCK	=> CHRONO_COUNTER_CLOCK,
			COUNTER_RESET	=> GLOBAL_RESET,
			COUNTER_ENABLE	=> COUNTER_CARRIER_5,
			COUNTER_MODE	=> CHRONO_COUNTER_MODE,
			COUNTER_LOAD	=> CHRONO_COUNTER_LOAD_6,
			COUNTER_OUTPUT	=> CHRONO_COUNTER_OUTPUT_6,
			COUNTER_CARRIER	=> COUNTER_CARRIER_6
		);
	COUNTER_7 : COUNTER
		generic map(
			COUNTER_N		=> CHRONO_COUNTER_N,
			COUNTER_LIMIT	=> CHRONO_COUNTER_LIMIT_7
		)
		port map(
			COUNTER_CLOCK	=> CHRONO_COUNTER_CLOCK,
			COUNTER_RESET	=> GLOBAL_RESET,
			COUNTER_ENABLE	=> COUNTER_CARRIER_6,
			COUNTER_MODE	=> CHRONO_COUNTER_MODE,
			COUNTER_LOAD	=> CHRONO_COUNTER_LOAD_7,
			COUNTER_OUTPUT	=> CHRONO_COUNTER_OUTPUT_7,
			COUNTER_CARRIER	=> COUNTER_CARRIER_7
		);
	GLOBAL_RESET <= COUNTER_CARRIER_7 OR CHRONO_COUNTER_RESET;
end architecture STRUCTURAL;